package com.saoma.logindemo.conf;

import com.saoma.logindemo.factory.CodeFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.stereotype.Component;

import javax.websocket.OnOpen;
import javax.websocket.Session;
import javax.websocket.server.PathParam;
import javax.websocket.server.ServerEndpoint;
import java.io.IOException;
import java.util.Iterator;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * @Classname WebSocketDemo
 * @Description
 * @Date 2021/2/209:52
 * @Author zjhchester
 */
@ServerEndpoint("/scanlogin/{code}")
@Component
public class WebSocketServer {
    private static Map<String, WebSocketServer> clients = new ConcurrentHashMap();
    private Session session;
    private String code;
    private static Integer threadStatus = 0;
    public WebSocketServer() {

    }
    private CodeFactory codeFactory = SpringUtil.getBean(CodeFactory.class);
    @OnOpen
    public void onOpen(@PathParam("code") String code, Session session) throws IOException {
        this.code = code;
        this.session = session;
        clients.put(code, this);

        System.out.println(code);
        codeFactory.setCode(code,session.toString());
        sendMessageTo("connect success!",code);
    }
    public void sendMessageTo(String message, String to) throws IOException {
        Iterator var3 = clients.values().iterator();
        while(var3.hasNext()) {
            WebSocketServer item = (WebSocketServer)var3.next();
            if (item.code.equals(to)) {
                item.session.getAsyncRemote().sendText(message);
            }
        }
    }
}
