package com.saoma.logindemo.controller;

import com.saoma.logindemo.conf.SpringUtil;
import com.saoma.logindemo.conf.WebSocketServer;
import com.saoma.logindemo.factory.CodeFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import java.io.IOException;
import java.util.Objects;
import java.util.UUID;

/**
 * @Classname scanDemo
 * @Description
 * @Date 2021/2/209:50
 * @Author zjhchester
 */
@RestController
public class ScanDemoController {
    private final static String TRUE= "true";
    private final CodeFactory codeFactory;
    private final WebSocketServer webSocketServer;
    public ScanDemoController(CodeFactory codeFactory, WebSocketServer webSocketServer) {
        this.codeFactory = codeFactory;
        this.webSocketServer = webSocketServer;
    }

    /**
     * 校验登陆
     * @return result
     */
    @GetMapping("/codeverify")
    public String codeCreate(String code) throws IOException {
        String session = codeFactory.getCode(code);
        if(Objects.nonNull(session)){
            System.out.println(session);
            codeFactory.setCode(code,"true");
            webSocketServer.sendMessageTo("已在手机上扫描，请确认登录",code);
        }
        return code;
    }


    @GetMapping("/confirmlogin")
    public Boolean confirmLogin(String code) throws IOException {
        String verifyResult = codeFactory.getCode(code);
        if(TRUE.equals(verifyResult)){
            SpringUtil.getBean(WebSocketServer.class).sendMessageTo("登录成功",code);
            return true;
        }else{
            return false;
        }
    }
}
