package com.saoma.logindemo.factory;

import org.springframework.stereotype.Component;

import java.util.concurrent.ConcurrentHashMap;

/**
 * @Classname CodeFacotory
 * @Description 扫码登录核心工厂
 * @Date 2021/2/209:56
 * @Author zjhchester
 */
@Component
public  class CodeFactory {
    /**
     * key: 生成的随机码
     * value: 绑定的socket  sessionID
     */
    private static ConcurrentHashMap<String,String> codeFactory;
    static {
        codeFactory = new ConcurrentHashMap<>(1);
    }
    public String getCode(String code){
        return codeFactory.get(code);
    }
    public String setCode(String code,String session){
        return codeFactory.put(code,session);
    }
}
